<script lang="ts">
  import { getLocalizer } from '../../module/utils.js'
  import Select from '../Select.svelte'

  import { getContext } from 'svelte'
  import { Writable } from 'svelte/store'
  import { attributeNames } from '../../module/model/character-data.js'
  import { timeUnits } from '../../module/model/item-data.js'
  import {
    SpellModificationCategories,
    SpellTargetClasses,
  } from '../../module/model/magic.js'
  import { createEventDispatcher } from 'svelte'

  const dispatch = createEventDispatcher()

  const localize = getLocalizer()

  let doc = getContext<Writable<any>>('doc')
  const attributeOptions = attributeNames.map((attributeName) => ({
    label: localize(attributeName),
    value: attributeName,
  }))

  const timeUnitOptions = timeUnits.map((timeUnit) => ({
    label: localize(timeUnit),
    value: timeUnit,
  }))

  function addVariant() {
    $doc.system.spellVariants = [
      ...($doc.system.spellVariants || []),
      {
        name: 'new variant',
        descrption: '',
        modificator: 0,
        minimalValue: 0,
        astralCost: undefined,
      },
    ]
    dispatch('change')
  }

  function deleteVariant(index) {
    $doc.system.spellVariants = $doc.system.spellVariants.filter(
      (_, i) => i !== index
    )
    dispatch('change')
  }
</script>

<div class="flexrow">
  <div data-testid="test-attributes">
    {localize('roll')}
    {#each ['firstAttribute', 'secondAttribute', 'thirdAttribute'] as attributeKey}
      <Select
        items={attributeOptions}
        bind:value={$doc.system.test[attributeKey]}
      />
    {/each}
  </div>

  <div data-testid="spell-value">
    {localize('value')}
    <input
      type="number"
      bind:value={$doc.system.value}
      placeholder={localize('value')}
    />
  </div>

  <div data-testid="magic-resistance">
    {localize('magicResistance')}
    <input
      type="number"
      bind:value={$doc.system.magicResistance}
      placeholder={localize('magicResistance')}
    />
  </div>

  <div data-testid="cast-time">
    {localize('castTime')}
    <input
      type="number"
      bind:value={$doc.system.castTime.duration}
      placeholder={localize('castTime')}
    />
    <Select items={timeUnitOptions} bind:value={$doc.system.castTime.unit} />
  </div>

  <div data-testid="astral-cost">
    {localize('astralCost')}
    <input
      type="text"
      bind:value={$doc.system.astralCost}
      placeholder={localize('astralCost')}
    />
  </div>

  <div data-testid="range">
    {localize('range')}
    <input
      type="text"
      bind:value={$doc.system.range}
      placeholder={localize('range')}
    />
  </div>

  <div data-testid="effect-time">
    {localize('effectTime')}
    <input
      type="text"
      bind:value={$doc.system.effectTime}
      placeholder={localize('effectTime')}
    />
  </div>

  <div data-testid="requires-uphold">
    {localize('requiresUphold')}
    <input
      type="checkbox"
      bind:checked={$doc.system.requiresUphold}
      placeholder={localize('requiresUphold')}
    />
  </div>

  <div data-testid="lcd-page">
    {localize('lcdPage')}
    <input
      type="number"
      bind:value={$doc.system.lcdPage}
      placeholder={localize('lcdPage')}
    />
  </div>
</div>

<div class="flexrow">
  <div>
    {localize('targetClasses')}
    <div class="option-list" data-testid="target-classes">
      {#each SpellTargetClasses as targetClass}
        <div>
          <input
            type="checkbox"
            bind:group={$doc.system.targetClasses}
            value={targetClass}
            placeholder={localize(targetClass)}
          />
          {localize(targetClass)}
        </div>
      {/each}
    </div>
  </div>
  <div>
    {localize('modifications')}
    <div class="option-list" data-testid="modifications">
      {#each SpellModificationCategories.filter((category) => !['general', 'conditional'].includes(category)) as modification}
        <div>
          <input
            type="checkbox"
            bind:group={$doc.system.modifications}
            value={modification}
            placeholder={localize(modification)}
          />
          {localize(modification)}
        </div>
      {/each}
    </div>
  </div>
</div>

<div data-testid="description">
  {localize('description')}
  <textarea bind:value={$doc.system.description}></textarea>
</div>

<div>
  {localize('variants')}
  <!-- svelte-ignore a11y-click-events-have-key-events a11y-no-static-element-interactions a11y-missing-attribute -->
  <a on:click={() => addVariant()} data-testid="add-variant">+</a>
  <div data-testid="variants">
    {#each $doc.system.spellVariants || [] as variant}
      {localize('name')}
      <!-- svelte-ignore a11y-click-events-have-key-events a11y-no-static-element-interactions a11y-missing-attribute -->
      <a on:click={() => deleteVariant(0)}><i class="fas fa-trash"></i></a>
      <input
        type="text"
        bind:value={variant.name}
        placeholder={localize('name')}
      />

      {localize('modificator')}
      <input
        type="number"
        bind:value={variant.modificator}
        placeholder={localize('modificator')}
      />
      {localize('minimalValue')}
      <input
        type="number"
        bind:value={variant.minimalValue}
        placeholder={localize('minimalValue')}
      />
      {localize('astralCost')}
      <input
        type="text"
        bind:value={variant.astralCost}
        placeholder={localize('astralCost')}
      />
      {localize('description')}
      <textarea
        bind:value={variant.description}
        placeholder={localize('description')}
      />
    {/each}
  </div>
</div>

<style>
  .option-list {
    display: grid;
    grid-template-columns: repeat(3, 1fr);
  }
</style>
